import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:get/get.dart';
import 'package:get/get_core/src/get_main.dart';
import 'package:project_telephony/ui/user/set_password_page.dart';
import 'package:project_telephony/ui/widget/scaffold_theme_widget.dart';
import 'package:project_telephony/utils/user_tool.dart';

class SettingPage extends StatefulWidget {
  const SettingPage({Key? key}) : super(key: key);

  @override
  _SettingPageState createState() => _SettingPageState();
}

class _SettingPageState extends State<SettingPage> {
  @override
  Widget build(BuildContext context) {
    return ScaffoldThemeWidget(
      title: "个人信息",
      child: Container(
        padding: EdgeInsets.all(40.w),
        child: Column(
          children: [
            Row(
              children: [
                const Text(
                  '手机号',
                  style: TextStyle(
                    fontSize: 18,
                  ),
                ),
                const Spacer(),
                Text(
                  UserTool.userProvider.userInfo.phone,
                  style: const TextStyle(
                    fontSize: 18,
                    color: Colors.black38,
                  ),
                ),
                Icon(
                  Icons.arrow_forward_ios,
                  size: 30.w,
                ),
              ],
            ),
            const Divider(),
            GestureDetector(

              behavior: HitTestBehavior.opaque,
              onTap: (){
                Get.to(()=>const SetPasswordPage());
              },
              child: Row(
                children: [
                  const Text(
                    '密码',
                    style: TextStyle(
                      fontSize: 18,
                    ),
                  ),
                  const Spacer(),
                  Icon(
                    Icons.arrow_forward_ios,
                    size: 30.w,
                  ),
                ],
              ),
            ),
            const Divider(),
          ],
        ),
      ),
      onTap: () {},
    );
  }
}
